const inputEl = document.getElementById('query');

const search$ = fromEvent(inputEl, 'keyup').pipe(
  map(event => inputEl.value),
  startWith(inputEl.value),
  distinctUntilChanged(),
  debounceTime(100),
  switchMap(createAjaxRequest),
  map(data=>JSON.stringify(data,null,1))
);

search$.subscribe(createOutputObserver());

function createAjaxRequest(query) {
  return ajax("http://localhost:3000/movies?q=" +
    encodeURIComponent(query) + "&_page=1&_limit=15"
  ).pipe(
    map(ajaxResult => ajaxResult.response.map(movie =>
      movie.title + " (" + movie.year + ")"
    ))
  );
}
